"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = _default;

var _fs = _interopRequireDefault(require("fs"));

var _jsonStreamStringify = _interopRequireDefault(require("json-stream-stringify"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _construct(Parent, args, Class) { if (isNativeReflectConstruct()) { _construct = Reflect.construct; } else { _construct = function _construct(Parent, args, Class) { var a = [null]; a.push.apply(a, args); var Constructor = Function.bind.apply(Parent, a); var instance = new Constructor(); if (Class) _setPrototypeOf(instance, Class.prototype); return instance; }; } return _construct.apply(null, arguments); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

var JSONStringify = function JSONStringify() {
  for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
    args[_key] = arguments[_key];
  }

  return new Promise(function (resolve, reject) {
    var stream = _construct(_jsonStreamStringify["default"], args);

    stream.once('error', function () {
      try {
        var results = JSON.stringify.apply(JSON, args);
        resolve(results);
      } catch (error) {
        reject(error);
      }
    });
    var trunks = '';
    stream.on('data', function (trunk) {
      trunks += trunk;
    });
    stream.on('end', function () {
      resolve(trunks);
    });
  });
};

function _default() {
  for (var _len2 = arguments.length, args = new Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
    args[_key2] = arguments[_key2];
  }

  var pluginOptions = args[1];
  var options = Object.assign({
    extractedFile: './src/translations/aggregated.json',
    langFiles: [{
      path: './src/translations/ru.json',
      cleanUpNewMessages: false
    }, {
      path: './src/translations/en.json',
      cleanUpNewMessages: true
    }]
  }, pluginOptions);
  /**
   * @returns {Array}
   */

  function getTargetFileContent() {
    var doesFileExists = _fs["default"].existsSync(options.extractedFile);

    if (!doesFileExists) {
      return [];
    }

    var result = JSON.parse(_fs["default"].readFileSync(options.extractedFile));
    return Array.isArray(result) ? result : [];
  }
  /**
   * @returns {Object.<string, string>}
   */


  function getTargetLangFileContent(path) {
    var doesFileExists = _fs["default"].existsSync(path);

    if (!doesFileExists) {
      return {};
    }

    return Object.assign({}, JSON.parse(_fs["default"].readFileSync(path)));
  }
  /**
   * @param {{id: string}[]} existing
   * @param {{id: string}[]} descriptors
   *
   * @returns {{id: string}[]}
   */


  function mergeDescriptors(existing, descriptors) {
    return existing // Remove from existing all messages with id, that used in descriptors
    .filter(function (descriptor) {
      return descriptors.findIndex(function (_ref) {
        var id = _ref.id;
        return id === descriptor.id;
      }) === -1;
    }) // Merge with new descriptors array
    .concat(descriptors).sort(function (a, b) {
      return a.id < b.id ? -1 : a.id > b.id ? 1 : 0;
    });
  }

  function mergeMessages(cleanUpNewMessages, oldMessages, newMessages) {
    if (!cleanUpNewMessages) {
      return Object.assign(oldMessages, newMessages);
    }

    var result = Object.assign({}, oldMessages);
    Object.keys(newMessages).forEach(function (id) {
      if (!result[id]) {
        result[id] = '';
      }
    });
    return result;
  }

  return {
    post: function () {
      var _post = _asyncToGenerator(
      /*#__PURE__*/
      regeneratorRuntime.mark(function _callee2(file) {
        var _file$metadata$react, _file$metadata$react$;

        var descriptors, existingDescriptors, resultDescriptors, jsonStr, messages, promises;
        return regeneratorRuntime.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                if ((_file$metadata$react = file.metadata['react-intl']) === null || _file$metadata$react === void 0 ? void 0 : (_file$metadata$react$ = _file$metadata$react.messages) === null || _file$metadata$react$ === void 0 ? void 0 : _file$metadata$react$.length) {
                  _context2.next = 2;
                  break;
                }

                return _context2.abrupt("return");

              case 2:
                descriptors = file.metadata['react-intl'].messages;

                if (Array.isArray(descriptors)) {
                  _context2.next = 5;
                  break;
                }

                return _context2.abrupt("return");

              case 5:
                existingDescriptors = getTargetFileContent();
                resultDescriptors = mergeDescriptors(existingDescriptors, descriptors);

                if (resultDescriptors === null || resultDescriptors === void 0 ? void 0 : resultDescriptors.length) {
                  _context2.next = 9;
                  break;
                }

                return _context2.abrupt("return");

              case 9:
                _context2.next = 11;
                return JSONStringify(resultDescriptors, null, 2);

              case 11:
                jsonStr = _context2.sent;

                _fs["default"].writeFileSync(options.extractedFile, jsonStr);

                messages = {};
                resultDescriptors.forEach(function (_ref2) {
                  var id = _ref2.id,
                      defaultMessage = _ref2.defaultMessage;
                  messages[id] = defaultMessage || '';
                });
                promises = options.langFiles.map(
                /*#__PURE__*/
                function () {
                  var _ref4 = _asyncToGenerator(
                  /*#__PURE__*/
                  regeneratorRuntime.mark(function _callee(_ref3) {
                    var path, cleanUpNewMessages, resultMessages, jsonStr;
                    return regeneratorRuntime.wrap(function _callee$(_context) {
                      while (1) {
                        switch (_context.prev = _context.next) {
                          case 0:
                            path = _ref3.path, cleanUpNewMessages = _ref3.cleanUpNewMessages;
                            resultMessages = mergeMessages(cleanUpNewMessages, getTargetLangFileContent(path), messages);
                            _context.next = 4;
                            return JSONStringify(resultMessages, null, 2);

                          case 4:
                            jsonStr = _context.sent;

                            _fs["default"].writeFileSync(path, jsonStr);

                          case 6:
                          case "end":
                            return _context.stop();
                        }
                      }
                    }, _callee);
                  }));

                  return function (_x2) {
                    return _ref4.apply(this, arguments);
                  };
                }());
                _context2.next = 18;
                return Promise.all(promises);

              case 18:
              case "end":
                return _context2.stop();
            }
          }
        }, _callee2);
      }));

      function post(_x) {
        return _post.apply(this, arguments);
      }

      return post;
    }()
  };
}